unit samplefeeds;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,generic, ExtCtrls;

type
  TfrmSampleFeeds = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    lbYourFeeds: TListBox;
    Splitter1: TSplitter;
    Panel3: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListBox2: TListBox;
    TabSheet2: TTabSheet;
    ListBox5: TListBox;
    TabSheet3: TTabSheet;
    ListBox3: TListBox;
    TabSheet4: TTabSheet;
    ListBox4: TListBox;
    TabSheet5: TTabSheet;
    ListBox6: TListBox;
    TabSheet6: TTabSheet;
    ListBox7: TListBox;
    TabSheet7: TTabSheet;
    ListBox8: TListBox;
    TabSheet8: TTabSheet;
    ListBox9: TListBox;
    TabSheet9: TTabSheet;
    ListBox10: TListBox;
    Label2: TLabel;
    Panel4: TPanel;
    btnAdd: TButton;
    Panel5: TPanel;
    btnRemove: TButton;
    procedure btnRemoveClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    closeOk: boolean;
  public
    { Public declarations }
    procedure setFeeds(feedsList: array of TFeed);
    procedure addFeed(lb: TListBox);
  end;

var
  frmSampleFeeds: TfrmSampleFeeds;

implementation

procedure TfrmSampleFeeds.btnAddClick(Sender: TObject);
begin
   addFeed((PageControl1.ActivePage.Controls[0] as TListBox));
end;

procedure TfrmSampleFeeds.btnRemoveClick(Sender: TObject);
begin
   if lbYourFeeds.ItemIndex < 0 then exit;
   lbYourFeeds.Items.Delete(lbYourFeeds.ItemIndex);
end;

procedure TfrmSampleFeeds.Button1Click(Sender: TObject);
begin
   if MessageDlg('Save changes?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      closeOk := true;
      ModalResult := mrOk;
   end;
end;

procedure TfrmSampleFeeds.Button2Click(Sender: TObject);
begin
   if MessageDlg('Abandon changes?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      closeOk := true;
      ModalResult := mrCancel;
   end;
end;

procedure TfrmSampleFeeds.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   CanClose := closeOk;
end;

procedure TfrmSampleFeeds.FormCreate(Sender: TObject);
begin
   closeOk := false;
end;

procedure TfrmSampleFeeds.setFeeds(feedsList: array of TFeed);
var
   i: integer;
begin
   for i := 0 to length(feedsList)-1 do
      lbYourFeeds.Items.Add(feedsList[i].url);
end;


procedure TfrmSampleFeeds.addFeed(lb: TListBox);
var
   i: integer;
   url: string;
begin
   if lb.ItemIndex < 0 then exit;
   url := lb.Items[lb.ItemIndex];
   for i := 0 to lbYourFeeds.Items.count -1 do
   begin
      if lbYourFeeds.Items[i] = url then
      begin
         ShowMessage('Feed is already in your list');
         exit;
      end;
   end;

   lbYourFeeds.items.add(url);
end;

{$R *.dfm}

end.
